FORMAT: 1A
HOST: https://abcexpress.ru/api/v1

# АВС Экспресс API

# Group Аккаунты
API для регистрации, логина и выхода

## Регистрация [/register/]

### Создать новый аккаунт [POST]

+ Request (application/json)

        {
            "email": "example@test.com",
            "password": "testpass"
        }

+ Response 200 (application/json)

    + Body

            {
                "email": "example@test.com",
                "token": "fc02ddaca7b1337fee44606c9f51e9d5fa34c881c0669381e8886de3d1701c54'
            }

## Логин [/login/]

### Получить токен для аутентификации [POST]

+ Request (application/json)

        {
            "email": "example@test.com",
            "password": "testpass"
        }

+ Response 200 (application/json)

    + Body

            {
                "email": "example@test.com",
                "token": "fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54"
            }

## Выйти [/logout/]

### Выйти из аккаунта [POST]

+ Request

    + Headers

            Authorization: Token fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54

+ Response 204

# Group Товары

## Список категорий и подкатегорий [/categories/]

### Получить список всех категорий в виде дерева [GET]

+ Request

    + Headers

            Authorization: Token fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54

+ Response 200 (application/json)

    + Body

            [
                {
                    "id": 1,
                    "name": "Категория1",
                    "subcategories": [
                        {
                            "id": 3,
                            "name": "Категория2",
                            "subcategories": [
                                {
                                    "id": 4,
                                    "name": "Категория3",
                                    "subcategories": [
                                        {
                                            "id": 6,
                                            "name": "Категория4",
                                            "subcategories": []
                                        }
                                    ]
                                },
                                {
                                    "id": 8,
                                    "name": "Категория8",
                                    "subcategories": []
                                }
                            ]
                        },
                        {
                            "id": 2,
                            "name": "Категория6",
                            "subcategories": [
                                {
                                    "id": 7,
                                    "name": "Категория7",
                                    "subcategories": []
                                }
                            ]
                        }
                    ]
                },
                {
                    "id": 5,
                    "name": "Категория5",
                    "subcategories": []
                }
            ]

## Список товаров [/products{?q,categories,brands,order,image}]

+ Parameters
    + q: wires (optional, string) - запрос для поиска
    + categories: 15,17 (optional, array[number]) - одна или несколько категорий для фильтрации
    + brands: 12,13 (optional, array[number]) - один или несколько брендов для фильтрации
    + order: `-price` (optional, string) - одно или несколько условий сортировки
    + image: true (optional, boolean) - условие фильтрации по изображениям

### Получить список товаров [GET]

+ Request (application/json)

    + Headers

            Authorization: Token fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54

+ Response 200 (application/json)

    + Body

            [
                {
                    "bookmarked": False
                    "brand": 154,
                    "category": 4,
                    "count": 2,
                    "description": "Описание продукта3",
                    "id": 1,
                    "image": null,
                    "name": "Продукт3",
                    "price": "342.00",
                    "supplier": [
                        {
                            "id": 2,
                            "name": "Поставщик1"
                        }
                    ],
                    "vendor_code": "1235345"
                },
                {
                    "bookmarked": False
                    "brand": 3,
                    "category": 4,
                    "count": 22,
                    "description": "Описание продукта2",
                    "id": 2,
                    "image": null,
                    "name": "Продукт2",
                    "price": "3434.00",
                    "supplier": [
                        {
                            "id": 2,
                            "name": "Поставщик1"
                        }
                    ],
                    "vendor_code": "32423"
                },
                {
                    "bookmarked": True
                    "brand": 1,
                    "category": 1,
                    "count": 32,
                    "description": "Описание продукта1",
                    "id": 3,
                    "image": null,
                    "name": "Продукт1",
                    "price": "343.00",
                    "supplier": [
                        {
                            "id": 1,
                            "name": "Поставщик1"
                        }
                    ],
                    "vendor_code": "2134212"
                }
            ]


##  Детальный запрос товара [/products/{id}/]

+ Parameters
    + id: 3 (required, number) - id товара

### Получить детальный обзор товара [GET]


+ Request (application/json)

    + Headers

            Authorization: Token fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54

+ Response 200 (application/json)

    + Body

            {
                "bookmarked": False
                "brand": 1,
                "category": 1,
                "count": 32,
                "description": "Описание продукта1",
                "id": 3,
                "image": null,
                "name": "Продукт1",
                "price": "343.00",
                "supplier": [
                    {
                        "id": 1,
                        "name": "Поставщик1"
                    }
                ],
                "vendor_code": "2134212"
            }

+ Response 404

    + Body

            {
                "detail": "Not found."
            }


##  Добавление/удаление товара в избранное [/products/{id}/bookmark/]

+ Parameters
    + id: 3 (required, number) - id товара

###  Добавить в избранное (Удалить из избранного) [POST]


+ Request (application/json)

    + Headers

            Authorization: Token fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54

+ Response 200 (application/json)

    + Body

            {
                "detail": "Product with id=3 bookmarked."
            }

+ Response 204 (application/json)

+ Response 404

    + Body

            {
                "detail": "Not found."
            }



## Список брендов [/brands/]

### Получить список брендов [GET]

+ Request (application/json)

    + Headers

            Authorization: Token fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54


+ Response 200 (application/json)

    + Body

            [
                {
                    "id": 3,
                    "name": "Бренд1"
                },
                {
                    "id": 1,
                    "name": "Бренд2"
                },
                {
                    "id": 154,
                    "name": "Бренд3"
                }
            ]

# Group Поставщики

## Список поставщиков [/suppliers/]

### Получить список поставщиков [GET]

+ Request (application/json)

    + Headers

            Authorization: Token fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54

+ Response 200 (application/json)

    + Body

            [
                {
                    "addresses": [
                        {
                            "building": "3",
                            "city": "Моска",
                            "country": "Россия",
                            "street": "Мневники"
                        },
                        {
                            "building": "23",
                            "city": "Воронеж",
                            "country": "Россия",
                            "street": "Карла Маркса"
                        }
                    ],
                    "id": 2,
                    "name": "Поставщик1"
                },
                {
                    "addresses": [
                        {
                            "building": "32",
                            "city": "Воронеж",
                            "country": "Россия",
                            "street": "Студенческая"
                        }
                    ],
                    "id": 1,
                    "name": "Поставщик1"
                }
            ]

# Group Избранное

## Список избранных товаров [/bookmarks/]

### Получить список избранных товаров [GET]

+ Request (application/json)

    + Headers

            Authorization: Token fc02ddaca7b1337fee66776c9f51e9d5fa34c881c0669381e8886de3d1701c54

+ Response 200 (application/json)

    + Body

            [
                {
                    "bookmarked": True
                    "brand": 154,
                    "category": 4,
                    "count": 2,
                    "description": "Описание продукта3",
                    "id": 1,
                    "image": null,
                    "name": "Продукт3",
                    "price": "342.00",
                    "supplier": [
                        {
                            "id": 2,
                            "name": "Поставщик1"
                        }
                    ],
                    "vendor_code": "1235345"
                },
                {
                    "bookmarked": True
                    "brand": 3,
                    "category": 4,
                    "count": 22,
                    "description": "Описание продукта2",
                    "id": 2,
                    "image": null,
                    "name": "Продукт2",
                    "price": "3434.00",
                    "supplier": [
                        {
                            "id": 2,
                            "name": "Поставщик1"
                        }
                    ],
                    "vendor_code": "32423"
                },
                {
                    "bookmarked": True
                    "brand": 1,
                    "category": 1,
                    "count": 32,
                    "description": "Описание продукта1",
                    "id": 3,
                    "image": null,
                    "name": "Продукт1",
                    "price": "343.00",
                    "supplier": [
                        {
                            "id": 1,
                            "name": "Поставщик1"
                        }
                    ],
                    "vendor_code": "2134212"
                }
            ]